-- macro:
-- #showtooltip
-- /run ShamanMount:M(GetRunningMacro(),"ground_mount_name","flying_mount_name","shift_mount_name","ctrl_mount_name","alt_mount_name")
-- /click ShamanMount

CreateFrame("Button","ShamanMount",nil,"SecureActionButtonTemplate")
ShamanMountData = {["MacroName"]=nil,["GroundMountName"]=nil,["FlyingMountName"]=nil,["ShiftMountName"]=nil,["CtrlMountName"]=nil,["AltMountName"]=nil}
local GhostWolf = GetSpellInfo(2645)
local WaterWalking = GetSpellInfo(546)
local AbyssalSeahorse = GetSpellInfo(75207)
local SubduedSeaHorse = GetSpellInfo(98718)
local SeaTurtle = GetSpellInfo(64731)
local AzureWaterStrider = GetSpellInfo(118089)
local WaterWalkingMacro = "/cast [@player]"..WaterWalking.."\n"
local time=GetTime()
local _,Class=UnitClass("player")
local IsVashjir
local AbyssalOk
local SeaHorseOk
local SeaTurtleOk

function ShamanMount:M(MN,GMN,FMN,SMN,CMN,AMN)
  local InstanceType 
  local IsMoving = GetUnitSpeed("player")~=0
  local AzureOk = IsUsableSpell(AzureWaterStrider)
  local JustSubmerged = IsSubmerged() and GetTime()-time<1.0
  local FlyingOk = IsUsableSpell(FMN)
  local GroundOk = IsUsableSpell(GMN)
  local ShiftOk = IsUsableSpell(SMN)
  local CtrlOk = IsUsableSpell(CMN)
  local AltOk = IsUsableSpell(AMN)
  local nobg

  IsVashjir = strsub(GetMapInfo()~=nil and GetMapInfo() or "",0,7)=="Vashjir"
  AbyssalOk = IsUsableSpell(AbyssalSeahorse)
  SeaHorseOk = IsUsableSpell(SubduedSeaHorse)
  SeaTurtleOk = IsUsableSpell(SeaTurtle)
  _,InstanceType=IsInInstance()
  nobg = IsInInstance()~="pvp"
  ShamanMountData["MacroName"]=GetMacroInfo(MN)
  ShamanMountData["GroundMountName"]=GMN
  ShamanMountData["FlyingMountName"]=FMN~=nil and FMN or GMN
  ShamanMountData["ShiftMountName"]=SMN
  ShamanMountData["CtrlMountName"]=CMN
  ShamanMountData["AltMountName"]=AMN

  if not InCombatLockdown() then
    ShamanMount:SetAttribute("type","macro")
    if CanExitVehicle() then
      ShamanMount:SetAttribute("macrotext","/run VehicleExit()")
    elseif IsMounted() then
      ShamanMount:SetAttribute("macrotext","/dismount [noflying]")
    elseif IsShiftKeyDown() and ShiftOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..SMN)
    elseif IsControlKeyDown() and CtrlOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..CMN)
    elseif IsAltKeyDown() and AltOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..AMN)
    elseif IsMoving then
      ShamanMount:SetAttribute("macrotext","/cast "..GhostWolf)
    elseif JustSubmerged and FlyingOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..FMN)
    elseif JustSubmerged and AzureOk and nobg and Class~="SHAMAN" then
      ShamanMount:SetAttribute("macrotext","/cast "..AzureWaterStrider)
    elseif IsVashjir and AbyssalOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..AbyssalSeahorse)
    elseif SeaHorseOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..SubduedSeahorse)
    elseif SeaTurtleOk and IsSubmerged() then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..SeaTurtle)
    elseif FlyingOk and IsSubmerged() then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..FMN)
    elseif FlyingOk then
      ShamanMount:SetAttribute("macrotext","/cast "..FMN)
    elseif GroundOk then
      ShamanMount:SetAttribute("macrotext",WaterWalkingMacro.."/cast "..GMN)
    else
      ShamanMount:SetAttribute("macrotext","/cast "..GhostWolf)
    end
  end
end

ShamanMount:SetScript("OnEvent",function(self,event)
  IsVashjir = strsub(GetMapInfo()~=nil and GetMapInfo() or "",0,7)=="Vashjir"
  AbyssalOk = IsUsableSpell(AbyssalSeahorse)
  SeaHorseOk = IsUsableSpell(SubduedSeaHorse)
  SeaTurtleOk = IsUsableSpell(SeaTurtle)
  if event=="PLAYER_REGEN_DISABLED" then
    ShamanMount:UnregisterEvent("SPELL_UPDATE_USABLE")
    ShamanMount:UnregisterEvent("MODIFIER_STATE_CHANGED")
    self:SetAttribute("type","macro")
    self:SetAttribute("macrotext","/run if CanExitVehicle() then VehicleExit() end\n/cast [nomounted]"..GhostWolf.."\n/dismount [noflying]")
  end
  if event=="PLAYER_REGEN_ENABLED" then
    ShamanMount:RegisterEvent("SPELL_UPDATE_USABLE")
    ShamanMount:RegisterEvent("MODIFIER_STATE_CHANGED")
  end
  if event=="SPELL_UPDATE_USABLE" and not IsSubmerged() then
    time=GetTime()
  end
  if IsShiftKeyDown() and IsUsableSpell(ShamanMountData["ShiftMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["ShiftMountName"])
  elseif IsControlKeyDown() and IsUsableSpell(ShamanMountData["CtrlMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["CtrlMountName"])
  elseif IsAltKeyDown() and IsUsableSpell(ShamanMountData["AltMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["AltMountName"])
  elseif IsVashjir and IsSubmerged() and (AbyssalOk or Class~="SHAMAN" and GetSpellInfo(AbyssalSeahorse)) then
    SetMacroSpell(ShamanMountData["MacroName"],AbyssalSeahorse)
  elseif IsSubmerged() and (SeaHorseOk or Class~="SHAMAN" and GetSpellInfo(SubduedSeahorse)) then
    SetMacroSpell(ShamanMountData["MacroName"],SubduedSeahorse)
  elseif IsSubmerged() and (SeaTurtleOk or Class~="SHAMAN" and GetSpellInfo(SeaTurtle)) then
    SetMacroSpell(ShamanMountData["MacroName"],SeaTurtle)
  elseif IsUsableSpell(ShamanMountData["FlyingMountName"]) or Class~="SHAMAN" and IsFlyableArea() and GetSpellInfo(ShamanMountData["FlyingMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["FlyingMountName"])
  elseif IsUsableSpell(ShamanMountData["GroundMountName"]) or Class~="SHAMAN" and GetSpellInfo(ShamanMountData["GroundMountName"]) then
    SetMacroSpell(ShamanMountData["MacroName"],ShamanMountData["GroundMountName"])
  elseif Class=="SHAMAN" then
    SetMacroSpell(ShamanMountData["MacroName"],GhostWolf)
  end
end)

ShamanMount:RegisterEvent("PLAYER_LOGIN")
ShamanMount:RegisterEvent("PLAYER_REGEN_ENABLED")
ShamanMount:RegisterEvent("PLAYER_REGEN_DISABLED")
ShamanMount:RegisterEvent("SPELL_UPDATE_USABLE")
ShamanMount:RegisterEvent("UPDATE_MACROS")
ShamanMount:RegisterEvent("MODIFIER_STATE_CHANGED")